/*
 ============================================================================
 Name        : Descriptors2.cpp
 Copyright   : Symbian Academy, 2007
 Description : Exercise: Descriptors, Part 2
 ============================================================================
 */

//  Include Files  

#include <e32base.h>
#include <e32std.h>
#include <e32cons.h>            // Console

// Function prototype (C-style).
LOCAL_C void MainL();
GLDEF_C TInt E32Main();

//  Global Variables
LOCAL_D CConsoleBase* console;

// Constants
_LIT(KNewLine, "\n");

// Edit 14: Create a new function called void PrintWithNewLine.
//          It should have a read-only descriptor as a parameter and
//          print its contents to the console (that's a global object, you don't
//          have to send it to this function using a parameter!).
//          Next, do a second Printf with the KNewLine-text.






// Edit 19: Create a new function that creates and returns a new HBufC*.
//          The HBufC-object should be left on the cleanup stack.
//          For its contents use: _LIT(KHBuf, "I'm an: HBuf");
//          Make sure the function name is set correctly according to the
//          Symbian OS coding guidelines (there should be two suffixes!).






LOCAL_C void MainL()
	{
	// ------------------------------------------------------------------
	// Initialization
	// ------------------------------------------------------------------

	_LIT(KHelloWorld, "Hello World!");
	_LIT(KHello, "Hello ");
	_LIT(KWorld, "World!");
	_LIT(KCurBufferLength, "Current length: %d\n");

	// ------------------------------------------------------------------
	// Using RBuf
	// ------------------------------------------------------------------
	// ** Use the RBuf directly
	// Edit 1: Declare a new RBuf called "modifiableBuf" and initialize it with
	//         the contents of KHello. Now do "Edit 3 + 1a" below to ensure that you can
	//         run the example even before you are finished.


	// Edit 2: Use the literal KCurBufferLength to print the current length of the RBuf.
	
	// Edit 3: We will now call some potentially leaving code, so put the modifiableBuf
	//         onto the cleanup stack.
	
	// Edit 4: Resize the buffer to a maximum of 12 chars, the length should stay the same.
	
	// Edit 5: Append the literal KWorld to the modifiableBuf
	
	// Edit 6: Print the modifiableBuf, then KNewLine and then the current length
	//         of the buffer (as you did above).


	
	// Edit 7: Close the buffer to free the memory allocated for it.
	//         Do not pop it from the cleanup stack just yet, as we will reuse the variable,
	//         therefore it can stay there for now. But if we don't free the memory using Close()
	//         before assigning new contents, the old data will be leaked!
	

	// ** Reuse an RBuf and base it on a HBufC*
	// Edit 8: Create a HBufC* based on KHello. Do not put it on the cleanup stack.
	
	// Edit 9: Assign the memory allocated by the HBufC* to the RBuf we declared before (modifiableBuf),
	//         so that the RBuf owns the memory of the old HBufC*.
	
	// Edit 10: Once again, print the current length of the descriptor
	
	// Edit 11: Replace the contents of the modifiableBuf with the contents of KWorld 
	//          (hint: copy the contents)
	
	// Edit 12: Append a newline character. Find out why the program crashes now
	//          and fix the error.


	// Edit 1a: Destroy the buffer using the cleanup stack.
	

	// ------------------------------------------------------------------
	// Function parameters and return types
	// ------------------------------------------------------------------
	_LIT(KTBuf, "I'm a : TBuf");
	_LIT(KRBuf, "I'm an: RBuf");

	// ** Creating a function to print a string that accepts all kinds of descriptors.
	// Edit 13: Create a TBuf called str1 based on the contents of KTBuf
	
	// Edit 14: OUTSIDE OF MAINL! (see above)
	// Edit 15: Print str1 using the function of Edit 14 (PrintWithNewLine(str1))
	

	// Edit 16: Create an RBuf called str2 based on the contents of KRBuf


	// Edit 17: Print str2 using the function of Edit 14.
	
	// Edit 18: Free the memory allocated by str2.
	

	// ** Returning an HBufC* that's left on the cleanup stack.
	// Edit 19: OUTSIDE OF MAINL! (see above)
	// Edit 20: Use the function you just created to assign it to an HBufC*
	//          e.g. HBufC* str3 = [your function call];
	
	// Edit 21: Print str3 using the function of Edit 14.
	
	// Edit 22: Use the cleanup stack to delete the HBufC.
	

	// ------------------------------------------------------------------
	// TPtr and TPtrC
	// ------------------------------------------------------------------
	// ** Use a TPtr to modify the contents of str1 and a TPtrC to point to a part of the first TPtr.
	// Edit 21: Create a TPtr called ptr1 that should point to the contents of str1
	
	// Edit 22: Create a TPtrC called ptr2 that points to the 6-char long left part of the ptr1.
	//          Hint: Use the function Left(6) of the ptr1!
	
	// Edit 23: Replace char 4 of the ptr1 with 'n', char 5 with 'o'.


	// Edit 24: Print str1 and ptr2 using PrintWithNewLine() and notice 
	//          if and why str1 changed and what printing ptr2 results in.



	// ------------------------------------------------------------------
	// String to/from number conversion
	// ------------------------------------------------------------------
	_LIT(K123, "123");
	const TInt num456 = 456;
	_LIT(KLexResult, "String -> Number: %d\n");

	// Edit 25: Convert K123 to a number and print it to the console
	//          using the format-string KLexResult.
	//          Hint: use TLex.Val()


	
	
	
	// Edit 26: Convert num456 to a TBuf and print it using PrintWithNewLine().


	

	// ------------------------------------------------------------------
	// Unicode Conversion
	// ------------------------------------------------------------------
	_LIT8(K8BitString, "I'm only ASCII!");

	// Edit 27: Convert K8BitString to a Unicode-String (called str16) and 
	//          print it using PrintWithNewLine(). You don't need to use the
	//          conversion library for this, just do a simple conversion
	//          using Copy().

	
	

	}

// ------------------------------------------------------------------
// Main Application
// ------------------------------------------------------------------
GLDEF_C TInt E32Main()
	{
	// Create cleanup stack
	CTrapCleanup* cleanup = CTrapCleanup::New ();

	// Create output console
	_LIT(KTextConsoleTitle, "Console - Descriptors 2");
	TRAPD(createError, console = Console::NewL(KTextConsoleTitle, TSize(KConsFullScreen,KConsFullScreen)))
	;
	if ( createError)
		return createError;

	// Run application code inside TRAP harness
	__UHEAP_MARK;

	TRAPD(mainError, MainL())
	;
	_LIT(KTextFailed, "MainL() failed, leave code = %d\n");
	if ( mainError)
		{
		console->Printf (KTextFailed, mainError);
		}

	// Wait for the space key before exiting.
	// Generally better than accepting any key to prevent immediate shutdown
	// if a key has still been in the queue when the app. started.
	_LIT(KTextPressSpace, "\n[Press space to exit]\n");
	console->Printf (KTextPressSpace);
	while (console->Getch ()!= EKeySpace)
		{
		}

	// Check the state of the heap memory - if the same amount of memory
	// is available as before MainL() was executed, everything's fine.
	// Otherwise, a panic will be raised, which would result in a graphical
	// error dialog in an UI framework, but exits the application when
	// using the console mode.
	__UHEAP_MARKEND;

	// If the program passed the __UHEAP_MARKEND-macro, no memory
	// leaks were detected
	_LIT(KTextMemoryLeak, "\nNo memory leaks detected! [Press space]\n");
	console->Printf (KTextMemoryLeak);
	while (console->Getch ()!= EKeySpace)
		{
		}

	// Cleanup
	delete console;
	delete cleanup;
	return KErrNone;
	}
